/**
 * Created by xiaoqiang on 10/9/16.
 */
function setupWebViewJavascriptBridge(callback) {
  if (window.WebViewJavascriptBridge) {
    return callback(WebViewJavascriptBridge);
  }
  if (window.WVJBCallbacks) {
    return window.WVJBCallbacks.push(callback);
  }
  window.WVJBCallbacks = [callback];
  var WVJBIframe = document.createElement('iframe');
  WVJBIframe.style.display = 'none';
  WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
  document.documentElement.appendChild(WVJBIframe);
  setTimeout(function () {
    document.documentElement.removeChild(WVJBIframe);
  }, 0);
}
var Bridge = function () {
    function Bridge() {
    }
    Bridge.prototype.call = function (cmd, param, callback) {
      setupWebViewJavascriptBridge(function (b) {
        b.callHandler(cmd, param, callback);
      });
    };
    Bridge.prototype.listen = function (cmd, callback) {
      setupWebViewJavascriptBridge(function (b) {
        b.registerHanlder(cmd, callback);
      });
    };
    Bridge.prototype.saveFile = function (name, data) {
      this.call('save_file', {
        file: name,
        data: data
      }, function () {
      });
    };
    Bridge.prototype.readFile = function (name) {
      var defer = Q.defer();
      this.call('load_file', name, function (result) {
        if (result == 'null') {
          defer.reject(false);
        } else {
          defer.resolve(result);
        }
      });
      return defer.promise;
    };
    Bridge.prototype.deleteFile = function (name) {
      var defer = Q.defer();
      this.call('delete_file', name, function (result) {
        defer.resolve();
      });
      return defer.promise;
    };
    return Bridge;
  }();
var bridge = new Bridge();